/* NiuTrans.Tensor - an open-source tensor library
* Copyright (C) 2017, Natural Language Processing Lab, Northestern University.
* All rights reserved.
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
*   http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/

/*
* $Created by: JIANG Yufan (email: jiangyufan2018@outlook.com) 2019-04-05
*/

#ifndef __BINARY_H__
#define __BINARY_H__

#include "../../XTensor.h"

namespace nts { // namespace nts(NiuTrans.Tensor)

/*
scale all tensor entires
b = a * scale
*/
void _Scale(const XTensor * a, XTensor * b, int num);

/*
scale tensor entires
make a new tensor to keep the result and return it
b = a * scale
*/
XTensor Scale(const XTensor & a, int num);

//void Scale(const XTensor & a, XTensor & b, int num);

/*
descale tensor entires
b = a / scale
*/
void _DeScale(const XTensor * a, XTensor * b, int num);

/*
descale tensor entires
make a new tensor to keep the result and return it
b = a / scale
*/
XTensor DeScale(const XTensor & a, int num);

/*
shift tensor entires
b = a + shift
*/
void _Shift(const XTensor * a, XTensor * b, int num);

/*
shift tensor entires
make a new tensor to keep the result and return it
b = a + shift
*/
XTensor Shift(const XTensor & a, int num);

/*
mod tensor entires
b = a % mod
*/
void _Mod(const XTensor * a, XTensor * b, int num);

/*
mod tensor entires
make a new tensor to keep the result and return it
b = a % mod
*/
XTensor Mod(const XTensor & a, int num);

} // namespace nts(NiuTrans.Tensor)

#endif // end __BINARY_H__
